#include <WiFi.h>
#include <PubSubClient.h>
#include "ws2812b.h"

#define DIGITALPINNUMBER  10
#define NUM_LEDS  32

// WPA/WPA2 SSID and password
char ssid[]   = "benedict";      // your network SSID
char pass[]   = "spin6199";  // your network password
int  status   = WL_IDLE_STATUS;   // the Wifi status

char mqttServer[]     = "public.cloud.shiftr.io";  // MQTT server
int  mqttPort         = 1883;    // MQTT port
char clientId[]       = "arduino";    // client ID
char username[]       = "tintfull";    //instance name
char password[]       = "lkUe6nMd214aNpub";   //access token

//String from mqtt
String Red;
String Green;
String Blue;

//String to int
int red1;
int green1;
int blue1;

WiFiClient wifiClient;
PubSubClient client(wifiClient);

ws2812b ledstrip = ws2812b(DIGITALPINNUMBER , NUM_LEDS);

void setup()
{
  Serial.begin(9600);

  //connect to wifi
  while (status != WL_CONNECTED)
  {
    Serial.print("Attempting to connect to SSID: ");
    Serial.println(ssid);
    status = WiFi.begin(ssid, pass);
    delay(1000);       // wait 1 seconds for connection
  }

  //if connect print wifi data
  printWifiData();

  //setup MQTT
  client.setServer(mqttServer, mqttPort);

  //led strip begin
  ledstrip.begin();

  for (int i = 0; i < NUM_LEDS; i++)
  {
    ledstrip.setPixelColor(i, 10, 10, 10 );
  }
  ledstrip.show();
}

void loop()
{
  if (!client.connected())
  {
    reconnect();
  }

  client.loop();
  client.subscribe("/Unity-1");
  client.setCallback(callback);
}

void printWifiData()
{
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);
}

void callback(char* topic, byte * payload, unsigned int length)
{
  for (int i = 0; i < length; i++)
  {
    Serial.print((char)payload[i]);
  }
Serial.print((char)payload[0]);
Serial.print((char)payload[1]);
Serial.print((char)payload[2]);


//RGB選擇
  if (payload[0] == 'R') {
    for (int i = 0; i < NUM_LEDS; i++)
    {
      ledstrip.setPixelColor(i, 10, 0, 0);
    }
    ledstrip.show();
  }
  else if (payload[0] == 'G') {
    for (int i = 0; i < NUM_LEDS; i++)
    {
      ledstrip.setPixelColor(i, 0, 10, 0);
    }
    ledstrip.show();
  }
  else if (payload[0] == 'B') {
    for (int i = 0; i < NUM_LEDS; i++)
    {
      ledstrip.setPixelColor(i, 0, 0, 10);
    }
    ledstrip.show();
  }

//混色的接收值
  if (payload[0] == 'Y') {
    for (int i = 0; i < NUM_LEDS; i++)
    {
      ledstrip.setPixelColor(i, 10, 10, 0);
    }
    ledstrip.show();
  }
  else if (payload[0] == 'M') {
    for (int i = 0; i < NUM_LEDS; i++)
    {
      ledstrip.setPixelColor(i, 10, 0, 10);
    }
    ledstrip.show();
  }
  else if (payload[0] == 'C') {
    for (int i = 0; i < NUM_LEDS; i++)
    {
      ledstrip.setPixelColor(i, 0, 10, 10);
    }
    ledstrip.show();
  }
}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected())
  {
    Serial.println("Attempting MQTT connection...");

    // Attempt to connect
    if (client.connect(clientId, username, password))
    {
      Serial.println("MQTT connected");
    }
    else
    {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 1 seconds before retrying
      delay(1000);
    }
  }
}
